import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import com.softwarebasic.paypalplugin.ipn.*;
import com.softwarebasic.paypalplugin.util.*;
import com.softwarebasic.paypalplugin.*;

public class TestServlet extends HttpServlet
    implements IPNListener {

  //Initialize global variables
  public void init() throws ServletException {
  }

  //Process the HTTP Post request
  public void doPost(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException {

    String type = request.getParameter("Checkout");
    String email = request.getParameter("email");
    int ret = 0;
    if ("Checkout1".equals(type)){
      String cartName = request.getParameter("cartname");
      String amount = request.getParameter("cartamount");
      PayPalShoppingCart cart = new PayPalShoppingCart(cartName, new Double(amount).doubleValue());
      PayPalCheckout checkout = new PayPalCheckout(email);
      checkout.addIPNListener(this);
      ret = checkout.checkoutWithIPN(cart, request, response, this.getServletContext());
    }
    else if ("Checkout2".equals(type)){
      String itemName1 = request.getParameter("itemname1");
      String itemName2 = request.getParameter("itemname2");
      String price1 = request.getParameter("itemprice1");
      String price2 = request.getParameter("itemprice2");

      ArrayList items = new ArrayList();
      PayPalShoppingItem item1 = new PayPalShoppingItem(itemName1, new Double(price1).doubleValue());
      PayPalShoppingItem item2 = new PayPalShoppingItem(itemName2, new Double(price2).doubleValue());
      items.add(item1);
      items.add(item2);
      PayPalDetailsShoppingCart cart = new PayPalDetailsShoppingCart(items);
      PayPalCheckout checkout = new PayPalCheckout(email);
      checkout.addIPNListener(this);
      ret = checkout.checkoutWithIPN(cart, request, response, this.getServletContext());
    }
    if (ret == PayPalCheckout.SUCCESS) {
    }
    else if (ret == PayPalCheckout.FAIL_CONNECTION) {
    }
    else if (ret == PayPalCheckout.FAIL_LICENSE_EXPIRE) {
    }
  }

  //Process the HTTP Get request
  public void doGet(HttpServletRequest request, HttpServletResponse response) throws
      ServletException, IOException {
    doPost(request, response);
  }

  //Clean up resources
  public void destroy() {
  }

  public void ipnNotified(IPNEvent ipnEvent) {

    LoggerUtils.info("IPN Notified!!! event id = " + ipnEvent.getId());

    // check IPN status, such as "Pending", "Failed", "Denied",
    // "Refunded", "Canceled", please see details from PayPal's site.
    int ipnStatus = ipnEvent.getId();

    // STATUS_VERIFIED means payment "Completed" and checks of txnId,
    // receiverEmail, paymentAmount and paymentCurrency have been passed.
    if (ipnStatus == IPNTransaction.STATUS_VERIFIED) {

      // get all ipn variables
      IPNTransaction ipn = (IPNTransaction) ipnEvent.getSource();
      HashMap ipnVarMap = ipn.getIpnVariables();
      Set paramNames = ipnVarMap.keySet();
      for (Iterator iter = paramNames.iterator(); iter.hasNext(); ) {
        String paramName = (String) iter.next();
        String paramValue = (String) ipnVarMap.get(paramName);
        LoggerUtils.info("Response: Name = " + paramName + ", Value = " + paramValue);
      }

    }
    else if (ipnStatus == IPNTransaction.STATUS_PAYMENT_PENDING) {
      // To Do
    }
  }
}
